Index: .pydevproject
===================================================================
--- .pydevproject	(revision f468791f8ac1d2498ad79b33a2c4a0f06236dec8)
+++ .pydevproject	(revision 75eeb4259b6c50a745eb6eec9691323e3c4f077f)
@@ -4,5 +4,5 @@
 <pydev_property name="org.python.pydev.PYTHON_PROJECT_VERSION">python 2.7</pydev_property>
 <pydev_pathproperty name="org.python.pydev.PROJECT_SOURCE_PATH">
-<path>/code/src</path>
+<path>/trunk/src</path>
 </pydev_pathproperty>
 </pydev_project>
Index: src/sans/dataloader/data_info.py
===================================================================
--- src/sans/dataloader/data_info.py	(revision ffbe487235261db53473e1fe28d7b1953c7e31dd)
+++ src/sans/dataloader/data_info.py	(revision 75eeb4259b6c50a745eb6eec9691323e3c4f077f)
@@ -401,4 +401,38 @@
         return _str
     
+class TransmissionSpectrum:
+    """
+    Class that holds information about transmission spectrum
+    for white beams and spallation sources.
+    """
+    name = ''
+    timestamp = ''
+    ## Wavelength (float) [A]
+    wavelength = None
+    wavelength_unit = 'A'
+    ## Transmission (float) [unit less]
+    transmission = None
+    transmission_unit = ''
+    ## Transmission Deviation (float) [unit less]
+    transmission_deviation = None
+    transmission_deviation_unit = ''
+    
+    def __init__(self):
+        self.wavelength = []
+        self.transmission = []
+        self.transmission_deviation = []
+    
+    def __str__(self):
+        _str  = "Transmission Spectrum:\n"
+        _str += "   Name:       {0}".format(self.name)
+        _str += "   Timestamp:  {1}".format(self.timestamp)
+        _str += "   Wavelength [{0}] | Transmission [{1}] | Trans Dev [{2}]\n".format(self.wavelength_unit, self.transmission_unit, self.transmission_deviation_unit)
+        for i in range(len(self.wavelength)):
+            _str += "   {0}, {1}".format(self.wavelength[i], self.transmission[i])
+            if len(self.transmission_deviation > i):
+                _str += ", {0}".format(self.transmission_deviation[i])
+            _str += "\n"
+        return _str
+    
   
 class DataInfo:
@@ -431,4 +465,6 @@
     ## Collimation information
     collimation = None
+    ## Transmission Spectrum INfo
+    trans_spectrum = None
     ## Additional meta-data
     meta_data  = None
@@ -461,4 +497,6 @@
         ## Collimation information
         self.collimation = []
+        ## Transmission Spectrum
+        self.trans_spectrum = TransmissionSpectrum()
         ## Additional meta-data
         self.meta_data  = {}
Index: src/sans/dataloader/readers/cansas_constants.py
===================================================================
--- src/sans/dataloader/readers/cansas_constants.py	(revision eda89725afadff916f49a3a51d5823023263ff33)
+++ src/sans/dataloader/readers/cansas_constants.py	(revision 75eeb4259b6c50a745eb6eec9691323e3c4f077f)
@@ -15,5 +15,5 @@
                      "SASentry" : {
                                    "units_optional" : True,
-                                   "variable" : " ",
+                                   "variable" : None,
                                    "storeas" : "content",
                                    "attributes" : {"name" : {"variable" : "{0}.run_name[node_value] = \"{1}\""}},
@@ -26,8 +26,9 @@
                                                  "SASdata" : {
                                                               "attributes" : {"name" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\"",}},
+                                                              "variable" : None,
                                                               "children" : {"Idata" : {
                                                                                        "storeas" : "float",
+                                                                                       "units_optional" : False,
                                                                                        "variable" : None,
-                                                                                       "units_optional" : False,
                                                                                        "attributes" : {
                                                                                                        "name" : {
@@ -43,8 +44,8 @@
                                                                                                      "Q" : {
                                                                                                             "variable" : "{0}.x = numpy.append({0}.x, {1})",
-                                                                                                            "unit" : "_xunit",
+                                                                                                            "unit" : "x_unit",
                                                                                                             "attributes" : {
                                                                                                                             "unit" : {
-                                                                                                                                      "variable" : "{0}._xunit",
+                                                                                                                                      "variable" : "{0}._xunit = \"{1}\"",
                                                                                                                                       "storeas" : "content"
                                                                                                                                       }
@@ -53,8 +54,8 @@
                                                                                                      "I" : {
                                                                                                             "variable" : "{0}.y = numpy.append({0}.y, {1})",
-                                                                                                            "unit" : "_yunit",
+                                                                                                            "unit" : "y_unit",
                                                                                                             "attributes" : {
                                                                                                                             "unit" : {
-                                                                                                                                      "variable" : "{0}._yunit",
+                                                                                                                                      "variable" : "{0}._yunit = \"{1}\"",
                                                                                                                                       "storeas" : "content"
                                                                                                                                       }
@@ -63,4 +64,5 @@
                                                                                                      "Idev" : {
                                                                                                                "variable" : "{0}.dy = numpy.append({0}.dy, {1})",
+                                                                                                               "unit" : "y_unit",
                                                                                                                "attributes" : {
                                                                                                                                "unit" : {
@@ -72,4 +74,5 @@
                                                                                                      "Qdev" : {
                                                                                                                "variable" : "{0}.dx = numpy.append({0}.dx, {1})",
+                                                                                                               "unit" : "x_unit",
                                                                                                                "attributes" : {
                                                                                                                                "unit" : {
@@ -81,4 +84,5 @@
                                                                                                      "dQw" : {
                                                                                                               "variable" : "{0}.dxw = numpy.append({0}.dxw, {1})",
+                                                                                                              "unit" : "x_unit",
                                                                                                               "attributes" : {
                                                                                                                               "unit" : {
@@ -90,4 +94,5 @@
                                                                                                      "dQl" : {
                                                                                                               "variable" : "{0}.dxl = numpy.append({0}.dxl, {1})",
+                                                                                                              "unit" : "x_unit",
                                                                                                               "attributes" : {
                                                                                                                               "unit" : {
@@ -99,4 +104,5 @@
                                                                                                      "Qmean" : {
                                                                                                                 "storeas" : "content",
+                                                                                                                "unit" : "x_unit",
                                                                                                                 "variable" : "{0}.meta_data[\"{2}\"] = {1}",
                                                                                                                 "attributes" : {"unit" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\""}},
@@ -116,18 +122,39 @@
                                                               },
                                                  "SAStransmission_spectrum" : {
+                                                                               "variable" : None,
                                                                                "children" : {
                                                                                              "Tdata" : {
+                                                                                                        "storeas" : "float",
+                                                                                                        "variable" : None,
                                                                                                         "children" : {
                                                                                                                       "Lambda" : {
-                                                                                                                                  "variable" : "{0}.meta_data[\"{2}\"] = \"{1}\"",
-                                                                                                                                  "attributes" : {"unit" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\""}}
+                                                                                                                                  "variable" : "{0}.trans_spectrum.wavelength.append({1})",
+                                                                                                                                  "unit" : "trans_spectrum.wavelength_unit",
+                                                                                                                                  "attributes" : {
+                                                                                                                                                  "unit" : {
+                                                                                                                                                            "variable" : "{0}.trans_spectrum.wavelength_unit = \"{1}\"",
+                                                                                                                                                            "storeas" : "content"
+                                                                                                                                                            }
+                                                                                                                                                  }
                                                                                                                                   },
                                                                                                                       "T" : {
-                                                                                                                             "variable" : "{0}.meta_data[\"{2}\"] = \"{1}\"",
-                                                                                                                             "attributes" : {"unit" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\""}}
+                                                                                                                             "variable" : "{0}.trans_spectrum.transmission.append({1})",
+                                                                                                                             "unit" : "trans_spectrum.transmission_unit",
+                                                                                                                             "attributes" : {
+                                                                                                                                             "unit" : {
+                                                                                                                                                       "variable" : "{0}.trans_spectrum.transmission_unit = \"{1}\"",
+                                                                                                                                                       "storeas" : "content"
+                                                                                                                                                       }
+                                                                                                                                             }
                                                                                                                              },
                                                                                                                       "Tdev" : {
-                                                                                                                                "variable" : "{0}.meta_data[\"{2}\"] = \"{1}\"",
-                                                                                                                                "attributes" : {"unit" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\""}}
+                                                                                                                                "variable" : "{0}.trans_spectrum.transmission_deviation.append({1})",
+                                                                                                                                "unit" : "trans_spectrum.transmission_deviation_unit",
+                                                                                                                                "attributes" : {
+                                                                                                                                             "unit" : {
+                                                                                                                                                       "variable" : "{0}.trans_spectrum.transmission_deviation_unit = \"{1}\"",
+                                                                                                                                                       "storeas" : "content"
+                                                                                                                                                       }
+                                                                                                                                             }
                                                                                                                                 },
                                                                                                                       "<any>" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\""},
@@ -136,9 +163,10 @@
                                                                                              "<any>" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\""},
                                                                                              },
-                                                                               "attributes" : {"name" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\""},
-                                                                                               "timestamp" : {"variable" : "{0}.meta_data[\"{2}\"] = \"{1}\""},}
+                                                                               "attributes" : {"name" : {"variable" : "{0}.trans_spectrum.name = \"{1}\""},
+                                                                                               "timestamp" : {"variable" : "{0}.trans_spectrum.timestamp = \"{1}\""},}
                                                                                },
                                                  "SASsample" : {
                                                                 "attributes" : {"name" : {"variable" : "{0}.sample.name = \"{1}\""},},
+                                                                "variable" : None,
                                                                 "children" : {
                                                                               "ID" : {"variable" : "{0}.sample.ID = \"{1}\""},
@@ -171,4 +199,5 @@
                                                                               "position" : {
                                                                                             "children" : {
+                                                                                                          "variable" : None,
                                                                                                           "x" : {
                                                                                                                  "variable" : "{0}.sample.position.x = {1}",
@@ -205,4 +234,5 @@
                                                                                             },
                                                                               "orientation" : {
+                                                                                               "variable" : None,
                                                                                                "children" : {
                                                                                                              "roll" : {
@@ -246,12 +276,16 @@
                                                                 },
                                                  "SASinstrument" : {
+                                                                    "variable" : None,
                                                                     "children" : {
+                                                                                  "variable" : None,
                                                                                   "name" : {"variable" : "{0}.instrument = \"{1}\""},
                                                                                   "SASsource" : {
                                                                                                  "attributes" : {"name" : {"variable" : "{0}.source.name = \"{1}\""}},
+                                                                                                 "variable" : None,
                                                                                                  "children" : {
                                                                                                                "radiation" : {"variable" : "{0}.source.radiation = \"{1}\""},
                                                                                                                "beam_size" : {
                                                                                                                               "attributes" : {"name" : {"variable" : "{0}.source.beam_size_name = \"{1}\""}},
+                                                                                                                              "variable" : None,
                                                                                                                               "children" : {
                                                                                                                                             "x" : {
@@ -343,4 +377,5 @@
                                                                                                                                 },
                                                                                                                     "aperture" : {
+                                                                                                                                  "variable" : None,
                                                                                                                                   "attributes" : {
                                                                                                                                                   "name" : {"variable" : "{0}.name = \"{1}\""},
@@ -386,7 +421,11 @@
                                                                                                                                                                         }
                                                                                                                                                           },
-                                                                                                                                                "distance" : {"attributes" : {"unit" : {"variable" : "{0}.distance_unit = \"{1}\""}},
+                                                                                                                                                "distance" : {
+                                                                                                                                                              "storeas" : "float",
+                                                                                                                                                              "attributes" : {
+                                                                                                                                                                              "storeas" : "content",
+                                                                                                                                                                              "unit" : {"variable" : "{0}.distance_unit = \"{1}\""}},
                                                                                                                                                               "variable" : "{0}.distance = {1}",
-                                                                                                                                                              "unit" : "length_unit",
+                                                                                                                                                              "unit" : "distance_unit",
                                                                                                                                                               }
                                                                                                                                                 }
@@ -419,4 +458,5 @@
                                                                                                                           },
                                                                                                                  "offset" : {
+                                                                                                                             "variable" : None,
                                                                                                                              "children" : {
                                                                                                                                            "x" : {
@@ -453,4 +493,5 @@
                                                                                                                              },
                                                                                                                  "orientation" : {
+                                                                                                                                  "variable" : None,
                                                                                                                                   "children" : {
                                                                                                                                                 "roll" : {
@@ -481,4 +522,5 @@
                                                                                                                                   },
                                                                                                                  "beam_center" : {
+                                                                                                                                  "variable" : None,
                                                                                                                                   "children" : {
                                                                                                                                                 "x" : {
@@ -509,4 +551,5 @@
                                                                                                                                   },
                                                                                                                  "pixel_size" : {
+                                                                                                                                 "variable" : None,
                                                                                                                                  "children" : {
                                                                                                                                                "x" : {
@@ -551,9 +594,9 @@
                                                                     },
                                                  "SASprocess" : {
-                                                                 "variable" : " ",
+                                                                 "variable" : None,
                                                                  "children" : {
-                                                                               "name" : {"variable" : "{0}.name = \"{1}\""},
-                                                                               "date" : {"variable" : "{0}.date = \"{1}\""},
-                                                                               "description" : {"variable" : "{0}.description = \"{1}\""},
+                                                                               "name" : {"variable" : "{0}.name = \'{1}\'"},
+                                                                               "date" : {"variable" : "{0}.date = \'{1}\'"},
+                                                                               "description" : {"variable" : "{0}.description = \'{1}\'"},
                                                                                "term" : {
                                                                                          "variable" : None,
@@ -563,10 +606,12 @@
                                                                                                          }
                                                                                          },
-                                                                               "SASprocessnote" : {"children" : {"<any>" : {"variable" : "{0}.notes.append(\"{2}: {1}\")"}}},
-                                                                               "<any>" : {"variable" : "{0}.notes.append(\"{2}: {1}\")",}
+                                                                               "SASprocessnote" : {
+                                                                                                   "variable" : None,
+                                                                                                   "children" : {"<any>" : {"variable" : "{0}.notes.append(\'2}: {1}\')"}}},
+                                                                               "<any>" : {"variable" : "{0}.notes.append(\'{2}: {1}\')",}
                                                                                },
                                                                  },
-                                                 "SASnote" : {"variable" : "{0}.notes.append(\"{1}\")"},
-                                                 "<any>" : {"variable" : "{0}.meta_data[\"{2}\" = \"{1}\""},
+                                                 "SASnote" : {"variable" : "{0}.notes.append(\'{1}\')"},
+                                                 "<any>" : {"variable" : "{0}.meta_data[\"{2}\"] = \'{1}\'"},
                                                  }
                                    }
